<template lang="pug">
transition(name="fade" mode="out-in")
	the-main-layout(v-if="auth")
	.backdrop(v-else)
		transition(name="fade" mode="out-in")
			.backdrop__logo(v-if="loading")
			the-login-layout(v-else)
</template>

<script>
	import { onMounted, computed, ref, provide } from 'vue'
	import TheLoginLayout from '@/components/layouts/TheLoginLayout.vue'
	import TheMainLayout from '@/components/layouts/TheMainLayout.vue'
	import { useMainStore } from '@/store/main'

	export default {
		name: 'App',

		components: {
			TheLoginLayout,
			TheMainLayout,
		},

		setup() {
			const mainStore = useMainStore()
			const loading = ref(true)
			onMounted(async () => {
				try {
					await mainStore.getCurrentUser()
				} finally {
					loading.value = false
				}
			})
			return {
				auth: computed(() => mainStore.authorized),
				loading,
			}
		},
	}
</script>
